You're an excellent teacher, John. I find your videos not only extremely helpful, but impressively well-made - and it's not even so much about the format (which is ideal), but the way you teach and the examples you give. You explain things in a logical, progressive way, and you're excellent at providing the right level of exposure. I do wish there were more teachers like you in universities - but then, we might not have you on KZbin ;) Please keep going with these tutorials, you are contributing to the community in a huge way.
@stormybear49862 жыл бұрын
This was, legitimately, the most interesting java tutorial I've seen in years! EXCELLENT!!!!!
@19joni692 жыл бұрын
Making a sudoku solver was actually the very first project I programmed once I'd learned the basics. This takes me back.
@yahia13552 жыл бұрын
Wow ! I have been coding for arround 5 years and could'nt come up with a solution!
@19joni692 жыл бұрын
@@yahia1355 oh I didn't do anything smart. I literally brute forced a solution. Basically going over every single square and trying the first number that works, then if I got to one that had no possible correct number I would go back until the first square that I could have put a different number in and tried the different number. Do that until you can fill every square correctly. Just literally trying every combination until it works. There are much better ways to solve this. But the not so smart solution works.
@VishnuvardhanaReddyDeviReddy9 ай бұрын
@@19joni69 🤣🤣😂
@janekk33972 жыл бұрын
I'm so glad channels like this one exist. It was a part of my project and I would've never figured that out myself...
@krishnawadhwani53933 жыл бұрын
I had recently discovered this channel, haha, and I started to watch your videos on TV Like I am watching some movies or some kind of entertainment, nice videos keep it up, subscribed after watching 2-3 videos
@MykhailoZubanych3 жыл бұрын
Same)
@nikhilraov1003 жыл бұрын
This program works perfectly. What a flawless algorithm you have written .
@penguin78632 жыл бұрын
Sir before I watch your video I was a student who was struggling to solve recursion problems for my upcoming test. Now I get the idea about how to backtrack in recursion :) Huge thanks from South Korean student!
@jagi79762 жыл бұрын
It’s beautiful when something that’s educational is also entertaining
@luigiq64293 жыл бұрын
Great video John. Congrats on 500 subs!
@CodingWithJohn3 жыл бұрын
Thanks!!
@CodingWithJohn3 жыл бұрын
Well at least I've certainly gone well past 500
@ImHlkari23 күн бұрын
@@CodingWithJohn by far 😎
@Nikolai45673 жыл бұрын
I didn't think this solution would have an adequate time complexity. Thanks!
@JonasKeil2 жыл бұрын
This tutorial is excellent John.
@wombozombo Жыл бұрын
Fun way to learn about recursion 👍
@olayiwolaakinnagbe676 Жыл бұрын
This is the best video I found online for this problem. You are a great teacher, thank you.
@mthsffc2 жыл бұрын
This is exactly what I was looking for to complement my java studies. Projects with step-by-step explained. Please, keep it going, unfortunately here on KZbin, everything seems to be only JavaScript or Python. It would be great more projects with OOP.
@jhuluan-jyun25943 жыл бұрын
No wonder you’re a lead! Very clear sir, thank you
@saviobatista96192 жыл бұрын
Thank you! Amazing video, where I work I tried several times create something to solve our work schedule with some kind of algorithm but always fail, this was just exactly what I needed and hope to solve my needs. Thank you!
@rajeshg35702 жыл бұрын
This is excellent .. i simply love the naming conventions of the vars..which makes its easy to read and understand the logic
@sharadgupta85763 жыл бұрын
It was just really awesome and in so nice way u described it's just really wow... M so surprised why just so less likes I have watched couple of videos before but u just explained really understanding with gotcha learn some new concept as well successfully found my final year project as well thanks for making this video... I will surely check out your more videos.. Great job 👍
@navyathamarreddy28072 жыл бұрын
very nicely explained John, I saw few other videos as well for Sudoku Solver, but this is amazing!
@mdrwsh2 жыл бұрын
it is amazing to see various algorithms that be used to solve sudoku, i made one but using while loop
@joekagerer2 жыл бұрын
I wrote a Sudoku solver in 2008 in Javascript, but it didn't quite use full recursion (my mistake) so it wouldn't solve moderately difficult puzzles. Mine includes character recognition of uploaded websuduko puzzles. This week I added "paste from clipboard" so that I didn't have to save/load my puzzle images. Today, following your model I finally got mine solving even the "evil" puzzles. Thank You John for this great lesson. Although now I don't feel that "I wrote the code", my page works and I did right the optical character recognition parts. I don't believe that I can share a link here, but I can try.
@michaelkraemerman20092 жыл бұрын
This was such a good explanation!!! I feel a lot more confident about implementing this. Also thanks for not acting like this is easy/obvious👏
@carlostitlan Жыл бұрын
Your explanaition is soo cool! You even make feel this stuff is easy.
@LBCreateSpace2 ай бұрын
This was so nice and easy to follow! Thank you so much
@ulyses10182 жыл бұрын
Great video! Thanks for this kind of tutorials John! :D
@JannisAdmek3 жыл бұрын
You teaching skills are really impressive, great work! I have one minor point to critique, you hardcoded GRID_SIZE 9 but used 3 as a magic number. You could have computed it once sqrt(GRID_SIZE) or just declared it as a constant.
@Michael-se7ny3 жыл бұрын
sqrt(GRID_SIZE) would make no sense at all
@JannisAdmek3 жыл бұрын
@@Michael-se7ny Really? Doesn't a Sudoku box always have side length of sqrt(GRID_SIZE)? But I guess the really clean way would be to define the sudoku in terms of the BOX_SIZE, since GRID_SIZE has to be square number. so a normal sudoku is BOX_SIZE = 3. (GRID_SIZE = BOX_SIZE * BOX_SIZE)
@p_varma172 жыл бұрын
@@JannisAdmek right
@ChristForAll-1432 жыл бұрын
Simply Nailed It, AWESOME EXPLANATION
@footballalliance24123 жыл бұрын
Hi John, i have learned a lot from your videos. I hope you won't stop making videos in upcoming days, it is really helpful for us. I can guarantee you will get a huge subscribers in coming days.
@CodingWithJohn3 жыл бұрын
Thanks! Glad you're getting something out of them. I'll keep making them if people keep watching them!
@Bury112 жыл бұрын
cool project :) i'm fairly new to java, i programmed a small snake'ish game, so i understood the 2d array way better then i thought :D keep up the good work!
@qurdedu40322 жыл бұрын
Great explanation and great mini project Thank you so much. Looking for more project like this
@surjansr3 жыл бұрын
Great explanation. Will be great if we can also talk about the time complexity of the solutions
@robertoborelli32753 жыл бұрын
It's like O(k*10^(k^2 -n)) where k is the number of cells in a row and n is the number of placed numbers at the start. If you try with k greaters than 9 this algorithm would literally take years to find a solution. You can do better using sat solvers and translating the sudoko problem into cnf logical formulas.
@smrtfasizmu61612 жыл бұрын
@@robertoborelli3275 may I ask why do you have zero in the beginning of the expression 0(k * 10^(k^2 - n)) doesn't it just cancel everything to zero? Also, why do you have 10 to the power of cells to solve, how did you get 10? Did you mean k because with every added unsolved cell you need k times more traversing the loops (assuming that the number of rows = the number of digits you can fill a cell in) ? And why do you have k * in the beginning of the expression?
@robertoborelli32752 жыл бұрын
@@smrtfasizmu6161 it's been a while since I've watched the video and now I don't remember exactly the code but here I give you some explanations: 1) It's not a 0, but is a big O. This thing is called "Big O notation". Simplifying, you can read it as "the complexity is less or equal than..." but there are some formal and accurate mathematical definitions behind this intuition I gave. 2) The intuition behind the formula is that this code is clearly exponential in the number of unsolved cells (k^2 - n). 3) each time you call the function to see if a number is valid in cell you spend O(k) time. 4) For each cell there are (exactly) k possible values (in the case of normal sudoku k is 9). So to sum the important thing here are: - exponential in the number of unsolved cells. - you take linear time in k, each time you check if a number is valid So as I wrote in the previous comment this is a pretty easy solution to write and implement but it's very inefficient since it uses the technique 'guess and verify'. It's much better (but also a bit more difficult) to use a sat solver for this kinds of problems.
@juanmalpartida13332 жыл бұрын
Time complexity looks to be O(n^3) worst case. Average, eyeballing it, I would say is n^2*log(n)
@robertoborelli32752 жыл бұрын
@@juanmalpartida1333 no. just because you have 3 nested loops you can't always say that you have O(n^3). Inside this loop there is a recursion! This solution is exponential for sure, infact there are situations in which you guessed j correct values, than you are trying to fill the j+1-th value and you discover that there is no such a solution. In this case the algorithm does "backtracking" and there are situations in which all the j guessed valuesare wrong and the algorithm must re guess the entire solution. This leads to exponential cost!
@AkhtarReviews3 жыл бұрын
Loved it! 🔥
@abdurrouf41593 жыл бұрын
You just nailed it. Mind blowing tutorial, no doubt.
@neeldiyora35752 жыл бұрын
Excellent explanation 👏👏👏
@abidoyevictor27803 жыл бұрын
Well explained! Thanks John
@razvanungureanu8897 Жыл бұрын
I have reached the part where I didn't find a solution to erase the all the numbers of the board and to retry. I know it needed some recursion, but didn't figure out how. Your explanation was excellent and after reviewing your method, everything makes sense. Thanks and keep it up with these kind of videos!
@amaralensheriff Жыл бұрын
As always, thank you John.
@mynameispooop Жыл бұрын
Awesome Tutorial
@PathWars2 жыл бұрын
Awesome, exactly the kind of KZbin channel I wanted: Regularly uploaded coding videos.
@kunalkheeva2 жыл бұрын
How did you make it so simple, I always appreciate your content. your content is limited on youtube but whenever I get stuck in any problem and you have a video on that, which means, my last destiny is your video. Thank you
@jumpwer4 ай бұрын
Thanks John, I was really confused when I tried to solve questions like this based on the backtracking algo. You explain really well. Cheers :)
@zimbabwe81893 жыл бұрын
Great video, your explanation was pretty clear!
@alzaeem79 Жыл бұрын
Beautifully well explained, thank you sir.
@sigfigronath3 жыл бұрын
This was really nice, fun and informative!
@Garrison863 жыл бұрын
Amazing! Thanks for this, this helps me stay engaged in java
@vivekjj29862 жыл бұрын
Thanks so much John. I spent a lot of time searching on youtube for a good tutorial on this. I wish yours was the first video so i could have saved time :(
@verruu3332 жыл бұрын
if you could make a short tutorial about binary search trees and how to understand recursion there..
@francescopiazza48822 жыл бұрын
Great coding John! I got a "Hard Sudoku" solved in a few ms !
@staceyonuora53293 жыл бұрын
Great video, I really enjoyed your explanation. Super thanks, this was very helpful
@techtonight8823 жыл бұрын
I think we can use dynamic programming too, to reduce some of the complexity. We can use a HashMap to store if a number at particular position was a valid placement or not.
@kesarscorpio3 жыл бұрын
i guess this one is for beginners and that's why he chose this way of doing it
@cs05762 жыл бұрын
But that is dependent on the previous placements. So I do not immediately see how that improves this algorithm.
@smrtfasizmu61612 жыл бұрын
The argument of the hashmap needs to be both the board and the placement of the number. How does backtracking in your algorithm work? I am not sure how you intended to do it with hashmaps and make the code less complex than what you saw in this video. Can you elaborate further? One idea popped up in my mind, but it is more or less a copy of what you saw in the video but without recursion. First you have an array which holds the position which are given in the beginning. Then, you proceed filling in the board and every time you find out that you can't continue filling in the board you backtrack the i and j variables of the loop until you reach the next number which you filled in and continue trying filling it after setting number To Try to be 1+the previous numberToTry.
@mr.mirror12132 жыл бұрын
iirc the whole problem is a system of linear equation , and u can solve it in O(n) if u use multigrid method
@manusoftar2 жыл бұрын
I think that those nested for loops on the solve method are unecesary, you could add two additional params to send the current row and column and inside the function you just would need to either add the the rows or to the column depending on what you are doing... yes you will have to put some IF's, but the way you did it I think it will do unnecesary iterations, I mean, the last recursive call on a solvable board will put the needed number but there's nothing that would stop the initial call to the solve method from stopping it's iterations. Actually, on each recursive call it will have to traverse as far as possible on the board until sending back a false or a true if solved. You don't need the algorithm to traverse almost the whole board on each recursive call, you just need it to make a single step on the board instead.
@rams24782 жыл бұрын
WOW.. you are amazing....clean.. detailed.. explanation. Please do Leetcode problems also.. It will help us.
@shintaromidorima15522 жыл бұрын
it is 100% working teacher john and thank you for the source code
@surajverma-ut4kj2 жыл бұрын
Just one word for John 🙏🏼 Big ThankYou ❣️
@jaydoshi53943 жыл бұрын
Watching couple of videos from this channel every day in any order. But still makes sense
@siddhantanand57513 жыл бұрын
Hey, John I loved the way you went forward with explaining the video , you made it quite easy to learn the algorithm and fun too, i was curious if we can attach some image recognition tools like OpenCV etc for Java , so that we can scan a sudoku at run time and give an image back? I would love if you could show us how to do this if you like the idea.
@kingsuley0581 Жыл бұрын
Loved this!
@tonyz22032 жыл бұрын
OMG, I understand how to solve this complex problem now. Thank you so much!
@Pennervomland3 жыл бұрын
I‘d love to see this exact algorithm but more efficient. Knuths Algorithm X for sudoku sounds very interesting and shows a pretty good method for backtracking. I‘m too dumb to understand how to implement it in java but it could be a cool challenge for you.
@guidopiotrowski79003 жыл бұрын
Thanks for the great explanation! Keep it up with the channel!
@northnorth99133 жыл бұрын
I like what you doing, Hope you get the chance to do Dijkstra’s algorithm, Time complexity and a few more interview related. I like your explanations
@AdamantlyAdams2 жыл бұрын
Bro, thank you for teaching. You are the go to guy!
@38YD3 жыл бұрын
love this!
@Gandobilis Жыл бұрын
Very interesting tutorial!
@Daniel-iy1ed2 жыл бұрын
That was fantastic. Thanks 🙏
@b9944236 Жыл бұрын
Now I can solve it by myself, thanks a lot.
@estebanlegare Жыл бұрын
Really helpful!
@nagasivakrishna56602 жыл бұрын
wow,next level explanation
@stephanc71922 жыл бұрын
You make truly great videos
@josueramirez72472 жыл бұрын
In an intro to programming textbook I own, it mentions in the preface that one difference from prior printings is that it removes the sudoku solver example code from the multidimensional arrays chapter because apparently is it too complex at that point.
@danielmago43272 жыл бұрын
amazing professor!
@jefersonlerma57432 жыл бұрын
Pretty nice explanation. I made one sudoku solver but try to improve his performance using a priotityQueue. Basically save in the queue the empty spaces that can take the minimun posible values, so.. the queue delivery the spaces that have less probablity to change... and i reorder the probability of the other spaces that have been afected for add a new number in ther matrix. This consume so much memory but less time...
@CodingWithJohn2 жыл бұрын
Interesting methodology! This definitely isn't the most efficient way to do it but the board is limited to 9x9, so even with a terrible time complexity any board is still solved pretty quickly
@joedevenski32913 жыл бұрын
Fantastic stuff!
@ponder24062 жыл бұрын
Wow! That’s so cool! This was an awesome video! Very interesting :)
@abubakaradamu62783 жыл бұрын
I think, i just found my best youtuber. Keep up the good work John.
@patrickbradley49483 жыл бұрын
Same
@alpaslanbek3 жыл бұрын
It violated every clean code principle I know :D
@sritamabanerjee13313 жыл бұрын
Loved your explanation..keep it up buddy 😊
@Kanha03212 жыл бұрын
Its amazing ❤️
@BrianRotich-f7g Жыл бұрын
I learn more in 1 video than in 2 months worth of other tutorials
@cptsalazar49862 жыл бұрын
Awesome johnny...
@EminentInception942 жыл бұрын
Plumber, fireman, astronaut, father, and son. Now a JavaScript developer? Johnny Sinns has truly outdone himself
@CodingWithJohn2 жыл бұрын
I'm a man of many talents
@lukaskock70203 жыл бұрын
Thank you very much!
@許家文-z3m3 жыл бұрын
like your explain!! very clear!!!!!
@pendax2 жыл бұрын
What is the design process that leads to this design? In the video, the thinking is already done. I'd like to hear about the thinking.
@mohammadsadrayeganehfaal2323 Жыл бұрын
such a enjoyable algorithm!!!
@sweetysojrani93236 ай бұрын
Awesome algorithm. It would be nice, if you could also explain the time complexity of the algorithm in your video.
@djneils1003 жыл бұрын
this is a quality tutorial
@bartomiejpotaman6973 Жыл бұрын
Shit took me a while but I think that's why it was worth it. This video made recursion seem so much more intuitive. Thank you!
@mira1m1982 жыл бұрын
Great explanation, easy to understand, even for beginners :-) Thanks!
@ol_gr2 жыл бұрын
the algorithm sounds violently inefficient, but still a cool solution to a complex problem
@buddybuythis38892 жыл бұрын
Wow! Sooo nice and free! Instant sub and hooked. Binge time.
@strawberrykitty83379 ай бұрын
thank you so much!!!!!
@RomualdBrunet2 жыл бұрын
Using static methods and passing the board as parameter hurts my brain for some reason (vs using the board as an instance of a class)
@ae607210 ай бұрын
same! Why doesnt he use the board as an instance? Is there any special reason for this?
@Darya-pu6ik2 жыл бұрын
its fantastic, i really like the way you teach, its intresting! However, could we do it using DP or is the an NP?
@devoiddude3 жыл бұрын
Fantastic video and fantastic channel, your videos are great thanks .
@obitouchiha75452 жыл бұрын
Wow sir you can explain things very well, let aside being multitasker.
@sujay_hegde2 жыл бұрын
Wouldn't a better design be to embrace OOPS for what it is, and make Board an object with members Row and Column
@christophermcdermit38282 жыл бұрын
It is clearly just a fancy excuse to make a fiercly overpowered recusion process, basically like a 90's batch file. Have you found anyone who made an actual OOPS solver, because I want to watch that if you know where one is?
@samuelnilsson5505 Жыл бұрын
Love this
@javawocky Жыл бұрын
Very nice. I do this stuff for fun. Recently did one of those word search generators which you see kids books all the time. Way more interesting to do than you may initially think.